明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 3756|回复: 22

求一个画上悬窗的小程序

[复制链接]
发表于 2013-6-1 14:31 | 显示全部楼层 |阅读模式
5明经币
本帖最后由 ucuc2003 于 2013-6-5 09:40 编辑

画上悬窗要求:1、点选闭合区域内部,生成一个方框,并画出上悬窗
                      2、生成的方框和上悬窗随层,不用指定颜色和图层
                      3、生成的方框与原闭合区域相距50mm
                      4、可以点选多个闭合区,一次性生成这样的上悬窗,也可以框选
下面是一个拾取内部点创建边界的小程序。cad图是图例
(defun C:tt()
  (princ "\n拾取内部点创建边界:")
  (command "-boundary" pause)
  (princ)
)
附件: 您需要 登录 才可以下载或查看,没有帐号?注册

最佳答案

查看完整内容

No error check

本帖被以下淘专辑推荐:

发表于 2013-6-1 14:31 | 显示全部楼层
No error check[code="lisp]
(defun C:tt()
  (vl-load-com)
  (princ "\n拾取内部点创建上悬窗: ")
  (while (setq pt (getpoint))
    (setq ee (bpoly pt))
    (vla-offset (vlax-ename->vla-object ee) -50)
    (setq ee (entlast)
         pts (acet-ent-geomextents ee)          ; ET function
          pa (car pts)
          pc (cadr pts)
    )
    (command "pline" "none" pa "none"
      (mapcar
        (function (lambda (a b) (/ (+ a b) 2)))
        pc
        (list (car pa) (cadr pc))
     )
    "none"
     (list (car pc) (cadr pa))
     ""
    )  
  )   
  (princ)
)
[/code]

点评

没达到楼主的效果啊,运行后只画了矩形,没画矩形中二斜线,要改改  发表于 2013-6-3 20:50

评分

参与人数 1明经币 +1 收起 理由
ucuc2003 + 1 感谢关注!

查看全部评分

回复

使用道具 举报

 楼主| 发表于 2013-6-1 15:31 | 显示全部楼层
本帖最后由 ucuc2003 于 2013-6-5 10:33 编辑
Andyhon 发表于 2013-6-5 10:04
No error check

您好,刚才测试了,能实现批量点选。能不能增加框选功能?
回复

使用道具 举报

发表于 2013-6-3 14:47 | 显示全部楼层
这个最好是点选才好用的,测试上面的程序发现没上悬窗的中间的交叉线,加上就完美了
回复

使用道具 举报

 楼主| 发表于 2013-6-3 15:25 | 显示全部楼层
bai2000 发表于 2013-6-7 09:47
这个最好是点选才好用的,测试上面的程序发现没上悬窗的中间的交叉线,加上就完美了

有图吗?示意一下
回复

使用道具 举报

发表于 2013-6-3 20:09 | 显示全部楼层
本帖最后由 bai2000 于 2013-6-3 20:11 编辑
ucuc2003 发表于 2013-6-3 15:25
有图吗?示意一下


就是没有矩形中表示上悬铰链的两条斜线啊
回复

使用道具 举报

 楼主| 发表于 2013-6-3 20:15 | 显示全部楼层
(defun C:tt()
  (vl-load-com)
  (princ "\n拾取内部点创建上悬窗: ")
  (while (setq pt (getpoint))
    (setq ee (bpoly pt))
    (vla-offset (vlax-ename->vla-object ee) -50)
  )
  (princ)
)
试一下
回复

使用道具 举报

发表于 2013-6-3 21:53 | 显示全部楼层
...上悬铰链的两条斜线啊...

不欲外行人知之乎!?
回复

使用道具 举报

发表于 2013-6-8 21:48 | 显示全部楼层
安装ET否?
回复

使用道具 举报

 楼主| 发表于 2013-6-8 21:48 | 显示全部楼层
52幕墙设计 发表于 2013-6-12 16:48
安装ET否?

已经安装了!!
回复

使用道具 举报

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2017 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2018-10-18 00:28 , Processed in 0.272430 second(s), 36 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表